#include"NBC.h"
__inline void Crypt_Dec_Block_RoundFuction(unsigned short *input, unsigned short *output, unsigned short *key)//ÿֽܺ
{	
	output[4] = input[1];
	output[0] = Sboxtable[input[1] ^ key[0]] ^ input[4];
	output[5] = input[0];
	output[1] = Sboxtable[input[0] ^ key[1]] ^ input[6];
	output[6] = input[3];
	output[2] = Sboxtable[input[3] ^ key[2]] ^ input[5];
	output[7] = input[2];
	output[3] = Sboxtable[input[2] ^ key[3]] ^ input[7];
}
int Crypt_Dec_Block(unsigned char *input, int in_len, unsigned char *output, int *out_len, unsigned char *key, int keylen)//
{
	int keyshift = 0, i = 0, j = 0;
	unsigned short *pinput = (unsigned short*)input;
	unsigned short *poutput = (unsigned short*)output;
	unsigned short *pkey = (unsigned short*)key;
	unsigned short *tmp = NULL;

	Key_Schedule(key, 1, Subkey);

	for(i = 0; i < in_len/16; i++)
	{
		pkey = (unsigned short*)Subkey;
		for(j=0; j<32; j++)
		{ 
			poutput[4] = pinput[1];
			poutput[0] = Sboxtable[pinput[1] ^ pkey[0]] ^ pinput[4];
			poutput[5] = pinput[0];
			poutput[1] = Sboxtable[pinput[0] ^ pkey[1]] ^ pinput[6];
			poutput[6] = pinput[3];
			poutput[2] = Sboxtable[pinput[3] ^ pkey[2]] ^ pinput[5];
			poutput[7] = pinput[2];
			poutput[3] = Sboxtable[pinput[2] ^ pkey[3]] ^ pinput[7];
			tmp = pinput;
			pinput = poutput;
			poutput = tmp;
			pkey += 4;
		}
		memcpy(poutput, pinput + 4, 8);
		memcpy(poutput + 4, pinput, 8);
	
		pinput += 8;
		poutput += 8;
	}
	*out_len = in_len;
	return 0;
}
//int Crypt_Dec_Block_CBC(unsigned char *input, int in_len, unsigned char *output, int *out_len, unsigned char *key, int keylen)//
//{
//	int i = 0, j = 0;
//	int blocknum = in_len / 16;
//	unsigned short* pinput = (unsigned short*)input;
//	unsigned short* poutput = (unsigned short*)output;
//	unsigned short *pkey = (unsigned short*)key;
//	unsigned short *tmp = NULL, *tmpiv = NULL;
//	unsigned short *IV1 = (unsigned short *)calloc(16,1);
//	unsigned short *IV2 = (unsigned short *)calloc(16, 1);
//
//	Key_Schedule(key, 1, Subkey);
//
//	memset(IV1, 0, 16);
//
//	for (i = 0; i < blocknum; i++)
//	{
//		memcpy(IV2, pinput, 16);
//		pkey = (unsigned short*)Subkey;
//		for (j = 0; j < 32; j++)
//		{
//			poutput[4] = pinput[1];
//			poutput[0] = Sboxtable[pinput[1] ^ pkey[0]] ^ pinput[4];
//			poutput[5] = pinput[0];
//			poutput[1] = Sboxtable[pinput[0] ^ pkey[1]] ^ pinput[6];
//			poutput[6] = pinput[3];
//			poutput[2] = Sboxtable[pinput[3] ^ pkey[2]] ^ pinput[5];
//			poutput[7] = pinput[2];
//			poutput[3] = Sboxtable[pinput[2] ^ pkey[3]] ^ pinput[7];
//
//			tmp = pinput;
//			pinput = poutput;
//			poutput = tmp;
//			pkey += 4;
//		}
//		memcpy(poutput, pinput + 4, 8);
//		memcpy(poutput + 4, pinput, 8);
//
//		for (j = 0; j < 8; j++)
//			poutput[j] ^= IV1[j];
//
//		tmpiv = IV1;
//		IV1 = IV2;
//		IV2 = tmpiv;
//
//		pinput += 8;
//		poutput += 8;
//	}
//
//	*out_len = in_len;
//	return 0;
//}
int Crypt_Dec_Block_CBC(unsigned char* input, int in_len, unsigned char* output, int* out_len, unsigned char* key, int keylen)//
{
	int i = 0, j = 0;
	int blocknum = in_len / 16;
	unsigned short* pinput = (unsigned short*)input + in_len/2 -8;
	unsigned short* poutput = (unsigned short*)output + in_len / 2 - 8;
	unsigned short* pkey = (unsigned short*)key;
	unsigned short* tmp = NULL;

	Key_Schedule(key, 1, Subkey);


	for (i = blocknum-1; i > 0; i--)
	{
		pkey = (unsigned short*)Subkey;
		for (j = 0; j < 32; j++)
		{
			poutput[4] = pinput[1];
			poutput[0] = Sboxtable[pinput[1] ^ pkey[0]] ^ pinput[4];
			poutput[5] = pinput[0];
			poutput[1] = Sboxtable[pinput[0] ^ pkey[1]] ^ pinput[6];
			poutput[6] = pinput[3];
			poutput[2] = Sboxtable[pinput[3] ^ pkey[2]] ^ pinput[5];
			poutput[7] = pinput[2];
			poutput[3] = Sboxtable[pinput[2] ^ pkey[3]] ^ pinput[7];

			tmp = pinput;
			pinput = poutput;
			poutput = tmp;
			pkey += 4;
		}
		memcpy(poutput, pinput + 4, 8);
		memcpy(poutput + 4, pinput, 8);

		pinput -= 8;
		for (j = 0; j < 8; j++)
			poutput[j] ^= pinput[j];
		poutput -= 8;
	}
	pkey = (unsigned short*)Subkey;
	for (j = 0; j < 32; j++)
	{
		poutput[4] = pinput[1];
		poutput[0] = Sboxtable[pinput[1] ^ pkey[0]] ^ pinput[4];
		poutput[5] = pinput[0];
		poutput[1] = Sboxtable[pinput[0] ^ pkey[1]] ^ pinput[6];
		poutput[6] = pinput[3];
		poutput[2] = Sboxtable[pinput[3] ^ pkey[2]] ^ pinput[5];
		poutput[7] = pinput[2];
		poutput[3] = Sboxtable[pinput[2] ^ pkey[3]] ^ pinput[7];

		tmp = pinput;
		pinput = poutput;
		poutput = tmp;
		pkey += 4;
	}
	memcpy(poutput, pinput + 4, 8);
	memcpy(poutput + 4, pinput, 8);

	*out_len = in_len;
	return 0;
}
