#include"NBC.h"
__inline void Crypt_Enc_Block_RoundFunction(unsigned short *input, unsigned short *output, unsigned short *key)//ÿּܺ
{	
	output[11] = input[0];
	output[1] = Sboxtable[input[0] ^ key[0]] ^ input[8];
	output[14] = input[1];
	output[2] = Sboxtable[input[1] ^ key[1]] ^ input[9];
	
	output[13] = input[2];
	output[4] = Sboxtable[input[2] ^ key[2]] ^ input[10];
	output[9] = input[3];
	output[3] = Sboxtable[input[3] ^ key[3]] ^ input[11];

	output[15] = input[4];
	output[0] = Sboxtable[input[4] ^ key[4]] ^ input[12];
	output[12] = input[5];
	output[5] = Sboxtable[input[5] ^ key[5]] ^ input[13];

	output[8] = input[6];
	output[7] = Sboxtable[input[6] ^ key[6]] ^ input[14];
	output[10] = input[7];
	output[6] = Sboxtable[input[7] ^ key[7]] ^ input[15];
}
int Crypt_Enc_Block(unsigned char *input, int in_len, unsigned char *output,int *out_len, unsigned char *key, int keylen)//
{
	int i=0, j = 0;
	unsigned short *pinput = (unsigned short*)input;
	unsigned short *poutput = (unsigned short*)output;
	unsigned short *pkey = (unsigned short*)key;
	unsigned short *tmp = NULL;

	Key_Schedule(key, 0, Subkey);


	for(i=0; i < in_len/32; i++)
	{
		pkey = (unsigned short*)Subkey;
		for(j = 0; j < 38; j++)
		{ 
			//Crypt_Enc_Block_RoundFunction(pinput, poutput, pkey);//ÿһּܺ
			poutput[11] = pinput[0];
			poutput[1] = Sboxtable[pinput[0] ^ pkey[0]] ^ pinput[8];
			poutput[14] = pinput[1];
			poutput[2] = Sboxtable[pinput[1] ^ pkey[1]] ^ pinput[9];

			poutput[13] = pinput[2];
			poutput[4] = Sboxtable[pinput[2] ^ pkey[2]] ^ pinput[10];
			poutput[9] = pinput[3];
			poutput[3] = Sboxtable[pinput[3] ^ pkey[3]] ^ pinput[11];

			poutput[15] = pinput[4];
			poutput[0] = Sboxtable[pinput[4] ^ pkey[4]] ^ pinput[12];
			poutput[12] = pinput[5];
			poutput[5] = Sboxtable[pinput[5] ^ pkey[5]] ^ pinput[13];

			poutput[8] = pinput[6];
			poutput[7] = Sboxtable[pinput[6] ^ pkey[6]] ^ pinput[14];
			poutput[10] = pinput[7];
			poutput[6] = Sboxtable[pinput[7] ^ pkey[7]] ^ pinput[15];
			tmp = pinput;
			pinput = poutput;
			poutput = tmp;
			pkey += 8;
		}
		memcpy(poutput, pinput + 8, 16);
		memcpy(poutput + 8, pinput, 16);
		
		pinput += 16;
		poutput += 16;	
	}
	*out_len = in_len;
	return 0;
}

int Crypt_Enc_Block_Round(unsigned char *input,int in_len,unsigned char *output,int*out_len,unsigned char *key ,int keylen,int CryptRound)//һCryptRoundּܺ
{
	int i = 0, j = 0;
	unsigned short* pinput = (unsigned short*)input;
	unsigned short* poutput = (unsigned short*)output;
	unsigned short* pkey = (unsigned short*)key;
	unsigned short* tmp = NULL;

	Key_Schedule(key,  0, Subkey);

	for (i = 0; i < in_len / 32; i++)
	{
		pkey = (unsigned short*)Subkey;
		for (j = 0; j < CryptRound; j++)
		{
			//Crypt_Enc_Block_RoundFunction(pinput, poutput, pkey);//ÿһּܺ
			poutput[11] = pinput[0];
			poutput[1] = Sboxtable[pinput[0] ^ pkey[0]] ^ pinput[8];
			poutput[14] = pinput[1];
			poutput[2] = Sboxtable[pinput[1] ^ pkey[1]] ^ pinput[9];

			poutput[13] = pinput[2];
			poutput[4] = Sboxtable[pinput[2] ^ pkey[2]] ^ pinput[10];
			poutput[9] = pinput[3];
			poutput[3] = Sboxtable[pinput[3] ^ pkey[3]] ^ pinput[11];

			poutput[15] = pinput[4];
			poutput[0] = Sboxtable[pinput[4] ^ pkey[4]] ^ pinput[12];
			poutput[12] = pinput[5];
			poutput[5] = Sboxtable[pinput[5] ^ pkey[5]] ^ pinput[13];

			poutput[8] = pinput[6];
			poutput[7] = Sboxtable[pinput[6] ^ pkey[6]] ^ pinput[14];
			poutput[10] = pinput[7];
			poutput[6] = Sboxtable[pinput[7] ^ pkey[7]] ^ pinput[15];
			tmp = pinput;
			pinput = poutput;
			poutput = tmp;
			pkey += 8;
		}
		memcpy(poutput, pinput + 8, 16);
		memcpy(poutput + 8, pinput, 16);

		pinput += 16;
		poutput += 16;
	}
	*out_len = in_len;
	return 0;
}

int Crypt_Enc_Block_CBC(unsigned char *input, int in_len, unsigned char *output,int *out_len, unsigned char *key, int keylen)//
{
	int i=0, j = 0;
	unsigned short *pinput = (unsigned short*)input;
	unsigned short *poutput = (unsigned short*)output;
	unsigned short *pkey = (unsigned short*)key;
	unsigned short *tmp = NULL;
	unsigned short *IV = NULL;
	IV = tIV;
	Key_Schedule(key, 0, Subkey);

	for(i=0; i < in_len/32; i++)
	{
		pkey = (unsigned short*)Subkey;

		for(j=0; j<16; j++)
			pinput[j] ^= IV[j];

		for(j = 0; j < 38; j++)
		{ 
			//Crypt_Enc_Block_RoundFunction(pinput, poutput, pkey);//ÿһּܺ
			poutput[11] = pinput[0];
			poutput[1] = Sboxtable[pinput[0] ^ pkey[0]] ^ pinput[8];
			poutput[14] = pinput[1];
			poutput[2] = Sboxtable[pinput[1] ^ pkey[1]] ^ pinput[9];

			poutput[13] = pinput[2];
			poutput[4] = Sboxtable[pinput[2] ^ pkey[2]] ^ pinput[10];
			poutput[9] = pinput[3];
			poutput[3] = Sboxtable[pinput[3] ^ pkey[3]] ^ pinput[11];

			poutput[15] = pinput[4];
			poutput[0] = Sboxtable[pinput[4] ^ pkey[4]] ^ pinput[12];
			poutput[12] = pinput[5];
			poutput[5] = Sboxtable[pinput[5] ^ pkey[5]] ^ pinput[13];

			poutput[8] = pinput[6];
			poutput[7] = Sboxtable[pinput[6] ^ pkey[6]] ^ pinput[14];
			poutput[10] = pinput[7];
			poutput[6] = Sboxtable[pinput[7] ^ pkey[7]] ^ pinput[15];
			tmp = pinput;
			pinput = poutput;
			poutput = tmp;
			pkey += 8;
		}
		memcpy(poutput, pinput + 8, 16);
		memcpy(poutput + 8, pinput, 16);
		
		pinput += 16;//Ҫ࿪32ֽ
		IV = poutput;
		poutput += 16;	
	}
	*out_len = in_len;
	return 0;
}
