#include"NBC.h"
__inline void Crypt_Enc_Block_RoundFunction(unsigned short* input, unsigned short* output, unsigned short* key)//ÿּܺ
{
	output[5] = input[0];
	output[0] = Sboxtable[input[0] ^ key[0]] ^ input[4];
	output[7] = input[2];
	output[1] = Sboxtable[input[2] ^ key[2]] ^ input[6];
	output[4] = input[1];
	output[2] = Sboxtable[input[1] ^ key[1]] ^ input[5];
	output[6] = input[3];
	output[3] = Sboxtable[input[3] ^ key[3]] ^ input[7];
}
int Crypt_Enc_Block(unsigned char* input, int in_len, unsigned char* output, int* out_len, unsigned char* key, int keylen)//
{
	int i = 0, j = 0;
	unsigned short* pinput = (unsigned short*)input;
	unsigned short* poutput = (unsigned short*)output;
	unsigned short* pkey = (unsigned short*)key;
	unsigned short* tmp = NULL;

	Key_Schedule(key, 0, Subkey);
	for (i = 0; i < in_len >> 4; i++)
	{
		pkey = (unsigned short*)Subkey;
		for (j = 0; j < 34; j++)
		{
			poutput[5] = pinput[0];
			poutput[0] = Sboxtable[pinput[0] ^ pkey[0]] ^ pinput[4];
			poutput[7] = pinput[2];
			poutput[1] = Sboxtable[pinput[2] ^ pkey[2]] ^ pinput[6];
			poutput[4] = pinput[1];
			poutput[2] = Sboxtable[pinput[1] ^ pkey[1]] ^ pinput[5];
			poutput[6] = pinput[3];
			poutput[3] = Sboxtable[pinput[3] ^ pkey[3]] ^ pinput[7];

			tmp = pinput;
			pinput = poutput;
			poutput = tmp;
			pkey += 4;
		}
		memcpy(poutput, pinput + 4, 8);
		memcpy(poutput + 4, pinput, 8);

		pinput += 8;
		poutput += 8;
	}

	return 0;
}

int Crypt_Enc_Block_Round(unsigned char* input, int in_len, unsigned char* output, int* out_len, unsigned char* key, int keylen, int CryptRound)//һCryptRoundּܺ
{
	int i = 0, j = 0;
	unsigned short* pinput = (unsigned short*)input;
	unsigned short* poutput = (unsigned short*)output;
	unsigned short* pkey = (unsigned short*)key;
	unsigned short* tmp = NULL;
	
	Key_Schedule(key, 0, Subkey);
	for (i = 0; i < in_len / 16; i++)
	{
		pkey = (unsigned short*)Subkey;
		for (j = 0; j < CryptRound; j++)
		{
			Crypt_Enc_Block_RoundFunction(pinput, poutput, pkey);//ÿһּܺ
			tmp = pinput;
			pinput = poutput;
			poutput = tmp;
			pkey += 4;
		}
		memcpy(poutput, pinput + 4, 8);
		memcpy(poutput + 4, pinput, 8);

		pinput += 8;
		poutput += 8;
	}

	return 0;
}

int Crypt_Enc_Block_CBC(unsigned char* input, int in_len, unsigned char* output, int* out_len, unsigned char* key, int keylen)//
{
	int keyshift = 0, i = 0, j = 0;
	unsigned short* pinput = (unsigned short*)input;
	unsigned short* poutput = (unsigned short*)output;
	unsigned short* pkey = (unsigned short*)key;
	unsigned short* tmp = NULL;
	unsigned short* IV = tIV;
	
	Key_Schedule(key, 0, Subkey);
	for (i = 0; i < (in_len >> 4); i++)
	{
		for (j = 0; j < 8; j++)
			pinput[j] ^= IV[j];
		pkey = (unsigned short*)Subkey;
		for (j = 0; j < 34; j++)
		{
			//Crypt_Enc_Block_RoundFunction(pinput, poutput, pkey);//ÿһּܺ
			poutput[5] = pinput[0];
			poutput[0] = Sboxtable[pinput[0] ^ pkey[0]] ^ pinput[4];
			poutput[7] = pinput[2];
			poutput[1] = Sboxtable[pinput[2] ^ pkey[2]] ^ pinput[6];
			poutput[4] = pinput[1];
			poutput[2] = Sboxtable[pinput[1] ^ pkey[1]] ^ pinput[5];
			poutput[6] = pinput[3];
			poutput[3] = Sboxtable[pinput[3] ^ pkey[3]] ^ pinput[7];

			tmp = pinput;
			pinput = poutput;
			poutput = tmp;
			pkey += 4;
		}
		memcpy(poutput, pinput + 4, 8);
		memcpy(poutput + 4, pinput, 8);

		pinput += 8;//Ҫ࿪16ֽ
		//memcpy(IV, poutput, 16);
		IV = poutput;
		poutput += 8;
	}

	return 0;
}
